/*
 *
 *
Copyright (c) 1998-2001 Aristar, Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any,
must include the following acknowledgment:

"This product includes software developed by Aristar, Inc. (http://www.aristar.com/)."

Alternately, this acknowledgment may appear in the software itself, if and
wherever such third-party acknowledgments normally appear.

4. The names "Dialect" and "Aristar, Inc." must not be used to endorse or
promote products derived from this software without prior written permission.
For written permission, please contact info@aristar.com.

5. Products derived from this software may not be called "Dialect", nor may
"Dialect" appear in their name, without prior written permission of Aristar, Inc.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
ARISTAR, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This software consists of voluntary contributions made by many individuals
on behalf of Aristar, Inc.  For more information on Aristar, Inc.,
please see <http://www.aristar.com/>.

Portions of this software are based upon software freely available and
written by individuals not associated with Aristar, Inc.  Copyrights are
maintained in the relevant source code files.
 *
 *
 */

#ifndef _CFILE_MODULE_H___
#define _CFILE_MODULE_H___

//=================================================================
#include "DConfigGlobals.h"
#include "CImplementer.h"

#define FILE_MODULE_NAME	_T("filemod")

VALUE InitFileModule();

class CFileImpl : public CClassImpl {
public:
	CFileImpl();
	~CFileImpl();
	void __del__(VALUE* self){this->__del__(self, 0, NULL, NULL);};
	static void SetEOF(bool bEOF, VALUE* self);
	static VALUE __init__(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE __del__(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE dir(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE open(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE close(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE write(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE writeline(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE writetab(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE readline(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE WriteTerminator(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE readfile(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE exists(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE move(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE copy(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE mkdir(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE rmdir(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE file_info(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE file_seek(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE _delete(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE QuickSave(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE QuickLoad(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
	static VALUE file_setatt(VALUE* self, int argCount, VALUE args[], CInterpreter* pInterp);
};

//=================================================================
#endif	// _CFILE_MODULE_H___
