/*
 *
 *
Copyright (c) 1998-2001 Aristar, Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any,
must include the following acknowledgment:

"This product includes software developed by Aristar, Inc. (http://www.aristar.com/)."

Alternately, this acknowledgment may appear in the software itself, if and
wherever such third-party acknowledgments normally appear.

4. The names "Dialect" and "Aristar, Inc." must not be used to endorse or
promote products derived from this software without prior written permission.
For written permission, please contact info@aristar.com.

5. Products derived from this software may not be called "Dialect", nor may
"Dialect" appear in their name, without prior written permission of Aristar, Inc.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
ARISTAR, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This software consists of voluntary contributions made by many individuals
on behalf of Aristar, Inc.  For more information on Aristar, Inc.,
please see <http://www.aristar.com/>.

Portions of this software are based upon software freely available and
written by individuals not associated with Aristar, Inc.  Copyrights are
maintained in the relevant source code files.
 *
 *
 */

// DialectView.h : interface of the CDialectView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDFRM_H__56EEAB4C_C5EB_11D2_80D9_000000000000__INCLUDED_)
#define AFX_CHILDFRM_H__56EEAB4C_C5EB_11D2_80D9_000000000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#ifdef IDE_SUPPORT


#include "CodeEditWnd.h"

#ifdef __MDI__
#	define BASEVIEWWND	CMDIChildWnd
#else
#	define BASEVIEWWND	CWnd
#endif

class CDialectView : public BASEVIEWWND
{
	DECLARE_DYNCREATE(CDialectView)
public:
	CDialectView();
	virtual ~CDialectView();

	void SetHandles(HMENU hMenu = NULL, HACCEL hAccel = NULL) {
		// This is a hack function to access protected members
		#ifdef __MDI__
		m_hMenuShared = hMenu;
		m_hAccelTable = hAccel;
		#endif
	};
	void EditModified(bool bModified);
	bool Open(CString directory, CString filename);
	bool SaveAs();
	bool Save(bool bPrompt);
	bool FileToText(CString filename, CString& text);
	bool TextToFile(CString filename, CString text);
	void FlashLine(int line, COLORREF color);
	bool GetShowLineNumbers();
	void SetShowLineNumbers(bool bShow);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDialectView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	bool Find(CString text, bool bMatchCase);
	void Print(HDC hDC);
	void SetBreakpoint(int line, bool bBreak);
	void SetReadOnly(bool bReadOnly);
	void SetFileInfo(CString directory, CString filename);
	void GetFileInfo(CString& directory, CString& filename);
	CString m_Directory;
	CString m_Filename;
	CString GetFilename();
	void SetText(CString text);
	CString GetModuleName();
	CString GetText();
	// view for the client area of the frame.
	CCodeEditWnd m_CodeEditWnd;

	void OnProjectInsertbreakpoint();
	void OnEditCopy();
	void OnUpdateEditCopy(CCmdUI* pCmdUI);
	void OnEditCut();
	void OnUpdateEditCut(CCmdUI* pCmdUI);
	void OnEditDelete();
	void OnUpdateEditDelete(CCmdUI* pCmdUI);
	void OnEditPaste();
	void OnUpdateEditPaste(CCmdUI* pCmdUI);
	void OnEditCommentOut();
	void OnUpdateEditCommentOut(CCmdUI* pCmdUI);
	void OnEditUncomment();
	void OnUpdateEditUncomment(CCmdUI* pCmdUI);
	void OnEditIndent();
	void OnUpdateEditIndent(CCmdUI* pCmdUI);
	void OnEditUnindent();
	void OnUpdateEditUnindent(CCmdUI* pCmdUI);
	void OnEditRedo();
	void OnUpdateEditRedo(CCmdUI* pCmdUI);
	void OnEditSelectall();
	void OnEditUndo();
	void OnUpdateEditUndo(CCmdUI* pCmdUI);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	CString m_TempName;
	//{{AFX_MSG(CDialectView)
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif // IDE_SUPPORT


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDFRM_H__56EEAB4C_C5EB_11D2_80D9_000000000000__INCLUDED_)
