/*
 *
 *
Copyright (c) 1998-2001 Aristar, Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any,
must include the following acknowledgment:

"This product includes software developed by Aristar, Inc. (http://www.aristar.com/)."

Alternately, this acknowledgment may appear in the software itself, if and
wherever such third-party acknowledgments normally appear.

4. The names "Dialect" and "Aristar, Inc." must not be used to endorse or
promote products derived from this software without prior written permission.
For written permission, please contact info@aristar.com.

5. Products derived from this software may not be called "Dialect", nor may
"Dialect" appear in their name, without prior written permission of Aristar, Inc.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
ARISTAR, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This software consists of voluntary contributions made by many individuals
on behalf of Aristar, Inc.  For more information on Aristar, Inc.,
please see <http://www.aristar.com/>.

Portions of this software are based upon software freely available and
written by individuals not associated with Aristar, Inc.  Copyrights are
maintained in the relevant source code files.
 *
 *
 */

#include "stdafx.h"
#include "QBitmap.h"

CQBitmap::CQBitmap()
{

}

CQBitmap::~CQBitmap()
{

}

bool CQBitmap::LoadFile(CString filename, int dx, int dy)
{
#ifdef UNDER_CE
	HBITMAP hbm = SHLoadDIBitmap(filename);
#else
	HBITMAP hbm = (HBITMAP)LoadImage(NULL, (LPCTSTR)filename, IMAGE_BITMAP,
		dx, dy, LR_LOADFROMFILE | LR_CREATEDIBSECTION);
#endif

	if (hbm == NULL) return false;
	DeleteObject();	// Free any previous bitmap data
	return Attach(hbm) != 0;
}

CQBitmap::CQBitmap(CQBitmap& copy)
{
	// Copy contructor
	if (this != &copy) {
		*this = copy;	// Invoke the assignment operator overload
	}
}

CQBitmap& CQBitmap::operator = (CQBitmap& copy)
{
	if (this != &copy) {
		DeleteObject();	// Free any previous bitmap data

		// Copy the bitmap (I'm sure there is a faster way)
		CDC source;
		source.CreateCompatibleDC(NULL); //compatible with the screen
		source.SelectObject(copy);

		BITMAP b;
		copy.GetBitmap(&b);
		CreateCompatibleBitmap(&source, b.bmWidth, b.bmHeight);

		CDC dest;
		dest.CreateCompatibleDC(&source);
		dest.SelectObject(this);

		dest.BitBlt(
			0,			// left dest
			0,			// top dest
			b.bmWidth,	// bm width
			b.bmHeight,	// bm height
			&source,	// pSrcDC
			0,			// left src
			0,			// top src
			SRCCOPY		// operation
		);
	}
	return *this;
}

