/*
 *
 *
Copyright (c) 1998-2001 Aristar, Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any,
must include the following acknowledgment:

"This product includes software developed by Aristar, Inc. (http://www.aristar.com/)."

Alternately, this acknowledgment may appear in the software itself, if and
wherever such third-party acknowledgments normally appear.

4. The names "Dialect" and "Aristar, Inc." must not be used to endorse or
promote products derived from this software without prior written permission.
For written permission, please contact info@aristar.com.

5. Products derived from this software may not be called "Dialect", nor may
"Dialect" appear in their name, without prior written permission of Aristar, Inc.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
ARISTAR, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This software consists of voluntary contributions made by many individuals
on behalf of Aristar, Inc.  For more information on Aristar, Inc.,
please see <http://www.aristar.com/>.

Portions of this software are based upon software freely available and
written by individuals not associated with Aristar, Inc.  Copyrights are
maintained in the relevant source code files.
 *
 *
 */

// QComboBox.cpp : implementation file
//

#include "stdafx.h"
#include "QComboBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CQComboBox

CQComboBox::CQComboBox(CQWindow* pQWindow, RECT& rc, int options,
					   VALUE (*pHandler)(CQComboBox*, int, VALUE), VALUE vSelf)
					   :CComboBox(), CQBase(vSelf)
{
	m_pHandler = pHandler;

	// The height affects the drop down portion size, not the size
	// the edit area.  Must make sure it is at least visible on drop down
	RECT r = rc;
	if (rc.bottom - rc.top < 100) r.bottom = r.top + 100;

	CreateEx(options & QCBS_BORDER ? WS_EX_CLIENTEDGE : 0,
		_T("COMBOBOX"), NULL,
		WS_CHILD | WS_VISIBLE |	WS_TABSTOP | WS_VSCROLL | CBS_AUTOHSCROLL | options,
		r.left, r.top, r.right - r.left, r.bottom - r.top,
		pQWindow->m_hWnd, NULL);

	SetFont(&g_QLabelFont);
}

CQComboBox::~CQComboBox()
{
}


BEGIN_MESSAGE_MAP(CQComboBox, CComboBox)
	//{{AFX_MSG_MAP(CQComboBox)
	ON_CONTROL_REFLECT(CBN_EDITCHANGE, OnEditchange)
	ON_CONTROL_REFLECT(CBN_DBLCLK, OnDblclk)
	ON_CONTROL_REFLECT(CBN_EDITUPDATE, OnEditupdate)
	ON_CONTROL_REFLECT(CBN_KILLFOCUS, OnKillfocus)
	ON_CONTROL_REFLECT(CBN_SELCHANGE, OnSelchange)
	ON_CONTROL_REFLECT(CBN_SETFOCUS, OnSetfocus)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQComboBox message handlers

void CQComboBox::OnEditchange()
{
	// TODO: Add your control notification handler code here

}

void CQComboBox::OnDblclk()
{
	if (m_pHandler) {
		m_pHandler(this, QW_DOUBLECLICK, VALUE());
	}
}

void CQComboBox::OnEditupdate()
{
	// TODO: Add your control notification handler code here

}

void CQComboBox::OnKillfocus()
{
	if (m_pHandler) {
		m_pHandler(this, QW_UNFOCUS, VALUE());
	}
}

void CQComboBox::OnSelchange()
{
	if (m_pHandler) {
		m_pHandler(this, QW_SELCHANGE, VALUE());
	}
}

void CQComboBox::OnSetfocus()
{
	if (m_pHandler) {
		m_pHandler(this, QW_FOCUS, VALUE());
	}
}

BOOL CQComboBox::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class

	return CComboBox::PreTranslateMessage(pMsg);
}

void CQComboBox::OnDestroy()
{
	CComboBox::OnDestroy();
	if (m_pHandler) m_pHandler(this, QW_DESTROY, VALUE());	// Causes garbage collection
}
