/*
 *
 *
Copyright (c) 1998-2001 Aristar, Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any,
must include the following acknowledgment:

"This product includes software developed by Aristar, Inc. (http://www.aristar.com/)."

Alternately, this acknowledgment may appear in the software itself, if and
wherever such third-party acknowledgments normally appear.

4. The names "Dialect" and "Aristar, Inc." must not be used to endorse or
promote products derived from this software without prior written permission.
For written permission, please contact info@aristar.com.

5. Products derived from this software may not be called "Dialect", nor may
"Dialect" appear in their name, without prior written permission of Aristar, Inc.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
ARISTAR, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This software consists of voluntary contributions made by many individuals
on behalf of Aristar, Inc.  For more information on Aristar, Inc.,
please see <http://www.aristar.com/>.

Portions of this software are based upon software freely available and
written by individuals not associated with Aristar, Inc.  Copyrights are
maintained in the relevant source code files.
 *
 *
 */

#ifndef _QGRID_H_
#define _QGRID_H_

#pragma once
// QGrid.h : header file
//

#include "QWindow.h"
#include "Grid.h"

//////////////////////////////////////////////////////////////////////////
// CQGrid window

class CQGrid : public CGrid, public CQBase
{
public:
	CQGrid(
		CQWindow* pQWindow,
		RECT& rc,
		int nrows, int ncols,
		int rowHeight,
		int colWidth[],
		int labelRowHeight,
		int labelColWidth,
		VALUE vEditFont, VALUE vLabelFont,
		VALUE (*pHandler)(CQGrid*, int, VALUE),
		VALUE vSelf);
	virtual ~CQGrid();

	VALUE (*m_pHandler)(CQGrid*, int, VALUE);

	virtual CString GetText(int row, int col);
	virtual void SetText(int row, int col, CString text);
	virtual void OnSelChange();
	virtual void OnFocus(int row, int col);

	void OnClick(int row, int col, int button, int down);

	void Clear();
	int GetRowCount();
	int GetColumnCount();
	void SetRowCount(int rows);
	bool SetContents(VALUE vArray);
	VALUE GetContents();
	bool SetRowHeaders(VALUE vArray);
	VALUE GetRowHeaders();
	bool SetColHeaders(VALUE vArray);
	VALUE GetColHeaders();

protected:
	CFont m_EditFont;
	CFont m_LabelFont;
	virtual void Set(int row, int col, CString text);
	virtual CString Get(int row, int col);
	CString **data;

public:
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CQGrid)
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CQGrid)
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}

#endif
