/*
 *
 *
Copyright (c) 1998-2001 Aristar, Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any,
must include the following acknowledgment:

"This product includes software developed by Aristar, Inc. (http://www.aristar.com/)."

Alternately, this acknowledgment may appear in the software itself, if and
wherever such third-party acknowledgments normally appear.

4. The names "Dialect" and "Aristar, Inc." must not be used to endorse or
promote products derived from this software without prior written permission.
For written permission, please contact info@aristar.com.

5. Products derived from this software may not be called "Dialect", nor may
"Dialect" appear in their name, without prior written permission of Aristar, Inc.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
ARISTAR, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This software consists of voluntary contributions made by many individuals
on behalf of Aristar, Inc.  For more information on Aristar, Inc.,
please see <http://www.aristar.com/>.

Portions of this software are based upon software freely available and
written by individuals not associated with Aristar, Inc.  Copyrights are
maintained in the relevant source code files.
 *
 *
 */

#if !defined(AFX_QLAYOUT_H__47589340_E131_11D2_9D5E_00105A1BD00B__INCLUDED_)
#define AFX_QLAYOUT_H__47589340_E131_11D2_9D5E_00105A1BD00B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// CQLayout.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CQLayout window

#include "QWindow.h"
#include "LayoutWindow.h"

#define QLYOS_BUTTONS		1
#define QLYOS_SINGLESECT	2
#define QLYOS_NOFORMNAME	4

class CQLayout;

class CQLayoutChild : public CLayoutWindow
{
public:
	CQLayoutChild(CQLayout* pParent, VALUE vLayout, VALUE vData,
		VALUE vRuleContext, bool bButtons = true, bool bSingleSect = false, bool bNoFormName = false);
	virtual void OnItemInfo(CString itemType, CString dataName, CString listName, VALUE vData, VALUE vItemOptions);
	CQLayout* m_pParent;
};

//
//	We could have derived CQLayout directory from CLayoutWindow except
//	for the fact that the CLayoutWindow automatically engulfs the entire
//	parent window on creation.  We could subsequently resize it down I
//	suppose.  Or modify the contructor to take a rect, or something else.
//	Also, CLayoutWindow always checks it's parent's client rect on WM_SIZE,
//	therefore if we alter the size of the window and it's parent window
//	isn't exactly the size we want the layout to be, all dimension are
//	thrown off.
//
class CQLayout : public CWnd, public CQBase
{
// Construction
public:
	CQLayout(CQWindow* pQWindow, RECT& rc, VALUE vLayout, VALUE vData,
		VALUE vRuleContext, int options,
		VALUE (*pHandler) (CQLayout*, int, VALUE), VALUE vSelf);

	VALUE (*m_pHandler)(CQLayout*, int, VALUE);

	CQLayoutChild* m_pLayoutChild;
	bool OnItemInfo(CString itemType, CString dataName, CString listName, VALUE vData, VALUE vItemOptions);
	void SetData(VALUE vData);
	VALUE GetData();
	void Update();
	VALUE GetFlashMenu();
	void SetFlashMenu(VALUE menu);
	void OnCommand(VALUE vCommand);
	void SetRuleContext(VALUE vFrame);
	VALUE GetRuleContext();
	bool GetSingleSection();
	bool SetSingleSection(bool bSingle);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CQLayout)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CQLayout();

	// Generated message map functions
protected:
	//{{AFX_MSG(CQLayout)
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_QLAYOUT_H__47589340_E131_11D2_9D5E_00105A1BD00B__INCLUDED_)
